#ifndef MORTSE_UI_H
#define MORTSE_UI_H

#define CURSOR_DELAY_MS 500;
#define LINE_LENGTH 16;

#include <Arduino.h>
#include "MortseGfx.h"

class MortseUI{

    private:
    //Graphics Library
    MortseGfx _gfx();

    //Cursor State
    enum cursorState _cursorStyle;
    bool _cursor_visible;
    unsigned long _nextCursorFlash;
    byte _cursorLine_buff;
    byte _cursorLine;
    byte _cursorPosition_buff;
    byte _cursorPosition;
    bool _updateCursor;

    char _line1[LINE_LENGTH];
    char _line2[LINE_LENGTH];
    char _line1_buff[LINE_LENGTH];
    char _line2_buff[LINE_LENGTH];
    bool _updateLine1;
    bool _updateLine2;

    //Line State



    //Cursor State Updates
    void _incrementCursor();
    void _toggleCursor();
    
    void _updateLine(byte &lineRef, byte &lineBuff, byte lineNo);


    public:
    MortseUI(byte port);

    /// @brief Called Every Frame
    void Tick();

    /// @brief Returns a pointer to the first line on the screen
    /// @param line1 character pointer array which is the length of LINE_LENGTH
    void GetLine1(char *line1);

    /// @brief Returns a pointer to the second line on the screen
    /// @param line2 character pointer array which is the length of LINE_LENGTH
    void GetLine2(char *line2);

    /// @brief Lets the graphics library know that the line1 array should be updated on the screen
    void UpdateLine1();

    /// @brief Lets the graphics library know that the line2 array should be updated on the screen
    void UpdateLine2();


    /// @brief Returns pointers to the line number and 
    /// @param line 
    /// @param position 
    void GetCursor(byte *line, byte* position);

    /// @brief Lets the graphics library know that the cursor position should be updated on the screen
    void UpdateCursor();

}

#endif